%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018-2019  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Converted_JT_Counter = Convert_PL_To_RBE2SEQ(Fastener_Index, Layer, Quad_RBE2_Stiffen_Strategy)

global ErrCode;

global DB_NODES;
global DB_MPC;

global AT_NODES;
global AT_MPC;

global DB_FASTENERS;

global db_Next_MPC_Number;
global db_Next_Node_Number;

% Инициализация счетчиков
Converted_JT_Counter = 0;

% Создание нового узла
Reference_Coord = DB_NODES{AT_NODES(DB_FASTENERS{Fastener_Index}.Joint_nodes(Layer))}.Reference_CID;
Analysis_Coord = DB_NODES{AT_NODES(DB_FASTENERS{Fastener_Index}.Joint_nodes(Layer))}.Analysis_CID;
Location = DB_FASTENERS{Fastener_Index}.Joint_nodes(Layer);

Append_To_Output(PCL_Node_Create(Reference_Coord, Analysis_Coord, Location));
Created_Node_ID = DB_Node_Create(Reference_Coord, Analysis_Coord, Location);
db_Next_Node_Number = db_Next_Node_Number + 1;

if (ErrCode < 0)
    return;
end

% Получение списка зависимых узлов по краям
Dep_Node_list = Shell_Node_Branch(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list, DB_FASTENERS{Fastener_Index}.Joint_nodes(Layer), Quad_RBE2_Stiffen_Strategy);

if (ErrCode < 0)
    return;
end

% Пополнение списка зависимых узлов
Dep_Node_list = Union_Column(Dep_Node_list, DB_FASTENERS{Fastener_Index}.Joint_nodes(Layer));

% Создание RBE2
Ind_Node = Created_Node_ID;
Dep_DOFs = 123456;

Append_To_Output(PCL_MPC_Create_RBE2(Ind_Node, Dep_Node_list, Dep_DOFs));
Created_MPC_ID = DB_MPC_Create_RBE2(Ind_Node, Dep_Node_list, Dep_DOFs);
db_Next_MPC_Number = db_Next_MPC_Number + 1;

if (ErrCode < 0)
    return;
end

% Ассоциирование болта с новым узлом
if (~isempty(DB_FASTENERS{Fastener_Index}.Offset_MPCs{Layer}))
    
    % Модификация MPC для офсета
    MPC_ID = DB_FASTENERS{Fastener_Index}.Offset_MPCs{Layer};
    Ind_Node = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.Offset_MPCs{Layer})}.ind_grid;
    Dep_Node_list = Created_Node_ID;
    Dep_DOFs = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.Offset_MPCs{Layer})}.dep_DOF;

    Append_To_Output(PCL_MPC_Modify_RBE2(MPC_ID, Ind_Node, Dep_Node_list, Dep_DOFs));
    DB_MPC_Modify_RBE2(MPC_ID, Ind_Node, Dep_Node_list, Dep_DOFs);

    if (ErrCode < 0)
        return;
    end
    
else
    
    switch DB_FASTENERS{Fastener_Index}.topology

        case 'bar_fastener'
            
            % Присоединение стержня болта к созданному узлу
            switch Layer
                case (1)
                    Element_list = DB_FASTENERS{Fastener_Index}.Shank_elements(1);
                case DB_FASTENERS{Fastener_Index}.N_layers
                    Element_list = DB_FASTENERS{Fastener_Index}.Shank_elements(DB_FASTENERS{Fastener_Index}.N_layers - 1);
                otherwise
                    Element_list = [DB_FASTENERS{Fastener_Index}.Shank_elements(Layer-1); DB_FASTENERS{Fastener_Index}.Shank_elements(Layer)];
            end

            Node_list = DB_FASTENERS{Fastener_Index}.Shank_nodes(Layer);
            Target_Node_list = Created_Node_ID;

            Append_To_Output(PCL_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list));
            DB_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list);

            if (ErrCode < 0)
                return;
            end
            
            % Внесение изменений в базу данных крепежа
            DB_FASTENERS{Fastener_Index}.Shank_nodes(Layer) = Created_Node_ID;
            
        case 'rutman_fastener'
            
            % Присоединение болта к созданному узлу
            Element_list = DB_FASTENERS{Fastener_Index}.Bush_elements{Layer};
            Node_list = DB_FASTENERS{Fastener_Index}.Additional_nodes(Layer);
            Target_Node_list = Created_Node_ID;

            Append_To_Output(PCL_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list));
            DB_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list);

            if (ErrCode < 0)
                return;
            end

            MPC_ID = DB_FASTENERS{Fastener_Index}.RBAR_MPCs(Layer);
            if (DB_FASTENERS{Fastener_Index}.Additional_nodes(Layer) == DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(Layer))}.ind_grid)
                Ind_Node = Created_Node_ID;
                Dep_Node = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(Layer))}.dep_grid;
                Dep_DOFs = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(Layer))}.dep_DOF;
            else
                Ind_Node = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(Layer))}.ind_grid;
                Dep_Node = Created_Node_ID;
                Dep_DOFs = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(Layer))}.dep_DOF;
            end

            Append_To_Output(PCL_MPC_Modify_RBAR(MPC_ID, Ind_Node, Dep_Node, Dep_DOFs));
            DB_MPC_Modify_RBAR(MPC_ID, Ind_Node, Dep_Node, Dep_DOFs);

            if (ErrCode < 0)
                return;
            end

            MPC_ID = DB_FASTENERS{Fastener_Index}.RBAR_MPCs(Layer+1);
            if (DB_FASTENERS{Fastener_Index}.Additional_nodes(Layer) == DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(Layer+1))}.ind_grid)
                Ind_Node = Created_Node_ID;
                Dep_Node = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(Layer+1))}.dep_grid;
                Dep_DOFs = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(Layer+1))}.dep_DOF;
            else
                Ind_Node = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(Layer+1))}.ind_grid;
                Dep_Node = Created_Node_ID;
                Dep_DOFs = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(Layer+1))}.dep_DOF;
            end

            Append_To_Output(PCL_MPC_Modify_RBAR(MPC_ID, Ind_Node, Dep_Node, Dep_DOFs));
            DB_MPC_Modify_RBAR(MPC_ID, Ind_Node, Dep_Node, Dep_DOFs);

            if (ErrCode < 0)
                return;
            end

            % Внесение изменений в базу данных крепежа
            DB_FASTENERS{Fastener_Index}.Additional_nodes(Layer) = Created_Node_ID;
            
        otherwise
            
            fprintf (1, '\nОшибка функции Convert_PL_To_RBE2SEQ: неизвестный тип топологии крепежа.\n');
            fprintf (1, 'Обратитесь к разработчику для решения этого вопроса.\n');
            ErrCode = -1;
            return;

    end
    
end

% Внесение изменений в базу данных крепежа
DB_FASTENERS{Fastener_Index}.Joint_nodes(Layer) = Created_Node_ID;
DB_FASTENERS{Fastener_Index}.Joint_topology{Layer} = 'plate_rbe2_sequential';
DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.MPC_ID = Created_MPC_ID;

% Обновление счетчика
Converted_JT_Counter = 1;
